<template>
  <q-toolbar class="bg-primary text-white raised" role="region" aria-label="Lijst">
    <q-toolbar-title>Dimensions
      <q-badge outline align="top" v-if="dimensions_filtered">
        {{ dimensions_filtered.length }}
      </q-badge>
      <q-badge align="top" outline v-else>0</q-badge>
    </q-toolbar-title>
    <q-checkbox label="Explicit" v-model="exclude_typed" dense dark tabindex="0"
                title="Toon enkel explicit dimensions"></q-checkbox>
  </q-toolbar>
  <q-card>
    <q-card-section>
      <q-input label="filter" v-model="search_value" autofocus tabindex="0" title="Filter lijst">
        <template v-slot:prepend>
          <q-icon name="filter_alt"/>
        </template>
      </q-input>
    </q-card-section>
  </q-card>

  <q-list bordered class="detail--padding scroll_list" :key="language_switch" role="region"
          aria-label="Lijst dimensions">
    <q-item clickable v-ripple
            v-for="(dimension, index) in dimensions_filtered"
            v-bind:id="dimension.concept_id"
            v-bind:key="index"
            active-class="active"
            :class="getClass(dimension)"
            :to="{name: 'dimension_detail',
                    params: {rowid: dimension.rowid, dts_name: dts_name}}">
      <q-item-section>
        <q-item-label v-html="show_label(dimension.concept)"></q-item-label>
      </q-item-section>
    </q-item>
    <q-inner-loading :showing="typeof this.dimensions=='undefined'">
      <q-circular-progress
        class="text-blue-grey"
        indeterminate
        size="50px"
        :thickness="0.22"
        v-if="typeof this.dimensions=='undefined'"></q-circular-progress>
    </q-inner-loading>

  </q-list>

</template>

<script>
import {api} from 'boot/axios'
import _ from 'lodash'
import SharedMethods from "components/SharedMethods";

export default {
  name: "DimensionList",
  created() {
    this.label_nice_role = SharedMethods.label_nice_role
    this.get_label = SharedMethods.get_label
    this.show_label = SharedMethods.show_label
    this.fetchData()
  },
  data() {
    return {
      dimensions: undefined,
      search_value: '',
      language_switch: undefined,
      exclude_typed: false,
    }
  },
  props: {
    dts_name: String,
    nt_version: String
  },

  methods: {
    fetchData: function () {
      api
        .get("/dts/" + this.dts_name + "/dimensions", {params: {nt_version: this.nt_version, full: 1}})
        .then(response => {
          this.dimensions = response.data
          if (this.dimensions.length && this.$route.fullPath.endsWith('dimensions')) {
            this.$router.push({
              name: 'dimension_detail',
              replace: true,
              params: {rowid: this.dimensions_filtered[0].rowid}
            })
          } else {
            this.$nextTick(() => {
              this.scroll_to_active()
            })
          }
        })
        .catch((error) => {
          this.dimensions = []
        })

    },
    scroll_to_active: function () {
      let activelist = document.getElementsByClassName('active')
      if (activelist.length) {
        let el = activelist[0]
        let offset = el.getBoundingClientRect().top - window.scrollY - 100
        if (offset > window.innerHeight || offset < 0) {
          this.$nextTick(() => {
              el.scrollIntoView(true)
            }
          )
        }
      }
    },
    getClass(dimension) {
      if (dimension.concept && dimension.concept.typed_domainref) {
        return 'typed'
      }
      return 'Not_so_much'
    }
  },
  computed: {
    dimensions_filtered() {
      const that = this
      let dummy = this.language_switch
      if (!_.isUndefined(this.search_value) && this.search_value.length > 1) {
        let filtered = this.dimensions.filter(dimension => dimension.concept_id &&
          this.get_label(dimension.concept).toLowerCase().includes(this.search_value.toLowerCase()))
        if (this.exclude_typed) {
          filtered = filtered.filter(dimension => !(dimension.concept && dimension.concept.typed_domainref))
        }
        return _.orderBy(filtered, [function (o) {
          return that.get_label(o)
        }])
      } else {
        if (this.exclude_typed) {
          let filtered = this.dimensions.filter(dimension => !(dimension.concept && dimension.concept.typed_domainref))
          return _.orderBy(filtered, [function (o) {
            return that.get_label(o)
          }])
        }
        return _.orderBy(this.dimensions, [function (o) {
          return that.get_label(o)
        }])
      }
    }
  },
  watch: {
    "$route.query.lang": function () {
      this.language_switch = this.$route.query.lang
    }
  }
}
</script>
ordered_by_name: function(concepts) {
return concepts, 'name')
},


<style scoped lang="scss">
.active {
  background: $primary;
  color: white;
  opacity: 0.9;
}

.scroll_list {
  overflow-y: auto;
  height: calc(100vh - 290px);
}

.typed {
  border-left: 10px solid $blue-grey;
}

.non_typed {
  border-left: 10px solid transparent;
}

</style>
